#
/*
 */

/*
 *      Memory special file
 *      minor device 0 is physical memory
 *      minor device 1 is kernel memory
 *      minor device 2 is EOF/RATHOLE
        rewritten to do word transfers whenever possible
                (requires slight change in mch.s!)   hjt.
 */

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/dir.h"
#include "../h/user.h"
#include "../h/conf.h"
#include "../h/seg.h"

mmread(dev)
{
        register c, bn, on;
        int a, d;
        int wordflag;

        if(minor(dev) == 2)
                return;
        do {
                bn = u.u_offset >> 6;
                on = u.u_offset & 077;
                a = UISA->r[0];
                d = UISD->r[0];
                wordflag = 0;
                spl7();
                UISA->r[0] = bn;
                UISD->r[0] = 077406;
                if(minor(dev) == 1)
                        UISA->r[0] = (ka6-6)->r[(bn>>7)&07] + (bn & 0177);
                fusuerr = 0;
                if (!(on&01)) {                 /* word boundary */
                        c = fuiword((caddr_t)on);
                        if  (fusuerr)
                                u.u_error = ENXIO;
                        else
                                wordflag++;
                } else {                        /* byte boundary */
                        if ((c = fuibyte((caddr_t)on)) < 0)
                                u.u_error = ENXIO;
                }
                UISA->r[0] = a;
                UISD->r[0] = d;
                spl0();
                if ((wordflag) && (!u.u_error)) {
                        if (passc(c) < 0) break;
                        c >>= 8;
                }
        } while(u.u_error==0 && passc(c)>=0);
}

mmwrite(dev)
{
        register c, bn, on;
        int a, d;
        int wordflag, t;

        if(minor(dev) == 2) {
                u.u_count = 0;
                return;
        }
        for(;;) {
                bn = u.u_offset >> 6;
                on = u.u_offset & 077;
                if ((c=cpass())<0 || u.u_error!=0)
                        break;
                wordflag = 0;
                if (( !(on&01) ) && ((t = cpass()) >= 0)) {
                        c = (t<<8) | (c&0377);
                        wordflag++;
                }
                a = UISA->r[0];
                d = UISD->r[0];
                spl7();
                UISA->r[0] = bn;
                UISD->r[0] = 077406;
                if(minor(dev) == 1)
                        UISA->r[0] = (ka6-6)->r[(bn>>7)&07] + (bn & 0177);
                if ((wordflag? suiword((caddr_t)on, c) : suibyte((caddr_t)on, c)) < 0)
                        u.u_error = ENXIO;
                UISA->r[0] = a;
                UISD->r[0] = d;
                spl0();
        }
}
